package type3;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

public class State {

	private String name;
	private List<Transition> transitions;
	private boolean isFinal;

	public State(String name) {
		this(name, false);
	}

	public State(String name, boolean isFinal) {
		this.name = name;
		this.transitions = new ArrayList<>();
		this.isFinal = isFinal;
	}

	public State with(Transition tr) {
		this.transitions.add(tr);
		return this;
	}

	public Set<State> transit(String c) {
		return transitions.stream().filter(t -> t.isPossible(c)).map(Transition::state).collect(Collectors.toSet());
	}

	public boolean isFinal() {
		return this.isFinal;
	}

	@Override
	public String toString() {
		return this.name;
	}

}
